/* -*- Mode: c++ -*- */

/*
 *Copyright:

 Copyright (C) 2002, 2003 Patrick Riley
 Copyright (C) 2001 Patrick Riley and Emil Talpes

 This file is part of the SPADES simulation system.

 The SPADES simulation system is free software; you can
 redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software
 Foundation; either version 2 of the License, or (at your option)
 any later version.

 The SPADES simulation system is distributed in the hope that it
 will be useful, but WITHOUT ANY WARRANTY; without even the implied
 warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with the SPADES simulation system; if not, write to
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 Boston, MA 02111-1307 USA

 *EndCopyright:
*/


#ifndef WRITABLE_OSTREAM_H_
#define WRITABLE_OSTREAM_H_

#include <unistd.h>
#include "Writable.hpp"

namespace spades
{
  
  //a simple class that provides writing to a file descriptor
  class WritableOStream
    : public spades::Writable
  {
  public:
    WritableOStream(std::ostream& os) : os(os) {}
    ~WritableOStream() {}

    //void setOStream(std::ostream& os) { this->os = os; }
    ostream& getOStream() const { return os; }

    bool write (const char* buf, int buflen) { os.write(buf, buflen); return os.good(); }

  private:
    std::ostream& os;
  };

}

#endif
